--- old/usr/src/uts/common/fs/doorfs/door_sys.c	2015-08-17 21:08:03.502874001 +0300
+++ new/usr/src/uts/common/fs/doorfs/door_sys.c	2015-08-17 21:08:03.511032700 +0300
@@ -1784,6 +1784,12 @@
 	setf(fd, fp);
 	dp->d_data.d_desc.d_descriptor = fd;
 
+	/* Add pid to the list associated with that descriptor. */
+	if (fp->f_vnode != NULL)
+		(void) VOP_IOCTL(fp->f_vnode, F_ASSOCI_PID,
+		    (intptr_t)curproc->p_pidp->pid_id, FKIOCTL, kcred, NULL,
+		    NULL);
+
 	/* Fill in the attributes */
 	if (VOP_REALVP(fp->f_vnode, &vp, NULL))
 		vp = fp->f_vnode;
